﻿using UnityEngine;
using System.Collections;

public class Actor : MonoBehaviour {
	protected Vector2 _motion = Vector2.zero;

	protected Direction _direction = Direction.Up;

	protected enum Direction{
		Up,
		Down,
		Left,
		Right,
		UpLeft,
		UpRight,
		DownLeft,
		DownRight
	}

	public void Update()
	{
		var rotation = Quaternion.LookRotation (Vector3.forward, _motion).eulerAngles;

		if (rotation.z >= 337.5f || rotation.z < 22.5f) {
			_direction = Direction.Up;
		}

		if (rotation.z >= 22.5f && rotation.z < 67.5f) {
			_direction = Direction.UpRight;
		}

		if (rotation.z >= 67.5f && rotation.z < 112.5f) {
			_direction = Direction.Right;
		}

		if (rotation.z >= 112.5f && rotation.z < 157.5f) {
			_direction = Direction.DownRight;
		}

		if (rotation.z >= 157.5f && rotation.z < 202.5f) {
			_direction = Direction.Down;
		}

		if (rotation.z >= 202.5f && rotation.z < 247.5f) {
			_direction = Direction.DownLeft;
		}

		if (rotation.z >= 247.5f && rotation.z < 292.5f) {
			_direction = Direction.Left;
		}

		if (rotation.z >= 292.5f && rotation.z < 337.5f) {
			_direction = Direction.UpLeft;
		}
	}
}
