﻿using UnityEngine;
using System.Collections;

[RequireComponent (typeof(SpriteRenderer))]
public class AnimatedSprite : MonoBehaviour {
	SpriteRenderer _spriteRenderer;
	float _index = 0;

	[SerializeField]
	float _animationSpeed = 5f;

	[SerializeField]
	Sprite[] _frames;

	void Awake()
	{
		_spriteRenderer = GetComponent<SpriteRenderer> ();
	}

	void Update () {
		if (_frames.Length > 0) {
			_spriteRenderer.sprite = _frames [(int)Mathf.Round(_index)];
		}

		_index += Time.deltaTime * _animationSpeed;
		if (_index >= _frames.Length-1)
			_index = 0;
	}
}
