﻿using UnityEngine;
using System.Collections;

public class BeatHit : MonoBehaviour {
	Vector3 _initialScale = new Vector3(6, 4, 1);

	bool _triggered = false;
	bool _onCooldown = false;

	float _scaleHitTime = 1.6f;

	float _scaleStep = 0f;

	float _mainCameraSize;

	public bool Triggered {
		get { return _triggered; }
		set { 
			if (value == true) {
				_triggered = value;
				Camera.main.orthographicSize = _mainCameraSize + 0.2f;
				_onCooldown = true;
				Invoke ("ResetCooldown", _scaleHitTime);
				PlayBeat ();
			} else {
				_triggered = value;
			}
		}
	}

	void Awake()
	{
		_mainCameraSize = Camera.main.orthographicSize;
	}

	void Update()
	{
		if (_triggered == true) {
			_scaleStep += Time.deltaTime/_scaleHitTime;
		}

		transform.localScale = Vector3.Lerp(transform.localScale, 
			Vector3.zero, 
			_scaleStep);

		Camera.main.orthographicSize = Mathf.Lerp (Camera.main.orthographicSize, _mainCameraSize, Time.deltaTime * 5f);
	}

	void PlayBeat()
	{
		transform.localScale = _initialScale;
		_scaleStep = 0f;
	}

	void ResetCooldown()
	{
		_onCooldown = false;
		_triggered = false;
	}

	public bool Active()
	{
		return transform.localScale.magnitude > 0.1f;
	}
}
