﻿using UnityEngine;
using System.Collections;

public class BoardDead : Actor {

	float _sine = 1f;

	[SerializeField]
	Sprite _boardUpSprite;
	[SerializeField]
	Sprite _boardRightUpSprite;
	[SerializeField]
	Sprite _boardLeftUpSprite;
	[SerializeField]
	Sprite _boardRightSprite;
	[SerializeField]
	Sprite _boardLeftSprite;

	SpriteRenderer _sprite;

	void Start () {
		if(Random.Range(0,1)>0.5f)
			_sine*=-1;

		_motion = new Vector3 (Random.Range (-1f, 1f), Random.Range (0f, 1f), 0f).normalized;

		_sprite = GetComponent<SpriteRenderer> ();
	}

	void Update () {
		base.Update ();
		transform.Translate (_motion * 2.5f * Time.deltaTime);

		Draw ();
	}

	void Draw()
	{
		if (_direction == Direction.Up) {
			_sprite.sprite = _boardUpSprite;
		}

		if (_direction == Direction.UpRight) {
			_sprite.sprite = _boardRightUpSprite;
		}

		if (_direction == Direction.Right) {
			_sprite.sprite = _boardRightSprite;
		}

		if (_direction == Direction.Left) {
			_sprite.sprite = _boardLeftSprite;
		}

		if (_direction == Direction.UpLeft) {
			_sprite.sprite = _boardLeftUpSprite;
		}

	}

	public Vector2 RotateVector(Vector2 v, float degrees) {
		float sin = Mathf.Sin(degrees * Mathf.Deg2Rad);
		float cos = Mathf.Cos(degrees * Mathf.Deg2Rad);

		float tx = v.x;
		float ty = v.y;
		v.x = (cos * tx) - (sin * ty);
		v.y = (sin * tx) + (cos * ty);
		return v;
	}
}

