﻿using UnityEngine;
using System.Collections;

public class HealthController : MonoBehaviour {
	[SerializeField]
	GameObject _heartContainer;

	[SerializeField]
	GameObject _waveContainer;

	[SerializeField]
	GameObject _heartsPrefab;

	[SerializeField]
	GameObject _waveIconPrefab;

	float _distanceBetweenHearts = 0.6f;

	int _startHealth = 3;
	public int _health;

	int _maxWaves = 3;

	void Start()
	{
		_health = _startHealth;
		for (var i = 0; i < _startHealth; i++) {
			var heart = Instantiate (_heartsPrefab
				, transform.position
				, Quaternion.identity) as GameObject;
			heart.transform.parent = _heartContainer.transform;
			heart.transform.localScale = Vector3.one;
		}

		for (var i = 0; i < _maxWaves; i++) {
			var waveIcon = Instantiate (_waveIconPrefab
				, transform.position
				, Quaternion.identity) as GameObject;
			waveIcon.transform.parent = _waveContainer.transform;
			waveIcon.transform.localScale = Vector3.one;
		}
	}

	void Update()
	{
		var waves = FindObjectsOfType<Wave> ();
		for (var i = 0; i < _waveContainer.transform.childCount; i++) {
			if (i < waves.Length) {
				_waveContainer.transform.GetChild (i).gameObject.SetActive (false);
			} else {
				_waveContainer.transform.GetChild (i).gameObject.SetActive (true);
			}
		}
	}

	public int Hurt()
	{
		_health--;
		for (var i = 0; i < _heartContainer.transform.childCount; i++) {
			if (_heartContainer.transform.GetChild (i).gameObject.activeSelf == true) {
				_heartContainer.transform.GetChild (i).gameObject.SetActive (false);
				break;
			}
		}

		return _health;
	}
}
