﻿using UnityEngine;
using System.Collections;

public class InputController : MonoBehaviour {
	[SerializeField]
	GameObject WavePrefab;

	Vector2 _touchBegan;

	void Update () {
		Swipe ();
	}

	void Swipe()
	{
		if(Input.GetMouseButtonDown(0)) {
			_touchBegan = MouseToWorld();
		}
		else if(Input.GetMouseButtonUp(0)){
			SwipeComplete (_touchBegan, MouseToWorld());
		}
	}

	Vector2 MouseToWorld()
	{
		var mouse = Camera.main.ScreenToWorldPoint (Input.mousePosition);
		return new Vector2 (mouse.x, mouse.y);
	}

	void SwipeComplete(Vector2 start, Vector2 end)
	{
		if (GameObject.FindGameObjectsWithTag ("Wave").Length > 2
		||
			(start - end).magnitude <= 0f)
			return;

		var rotation = Quaternion.LookRotation (Vector3.forward, start - end).eulerAngles;

		if (rotation.z > 260f) {
			end = start + Vector2.left + (Vector2.up/10f);
		}
		else if (rotation.z < 110f) {
			end = start + Vector2.right + (Vector2.up/10f);
		}

		var wave = (Instantiate (WavePrefab, start, Quaternion.identity/*Quaternion.LookRotation (Vector3.forward, end-start) * Quaternion.Euler(0f, 0f, 90f)*/) as GameObject).GetComponent<Wave> ();

		var motion = (end - start).normalized * 4f;

		wave.SetMotion(motion);
	}
}
