﻿using UnityEngine;
using System.Collections.Generic;

public class MultiplierController : MonoBehaviour {
	[SerializeField]
	GameObject[] _text;

	[SerializeField]
	Huey _huey;

	List<GameObject> _waveList;

	int _multiplier = 0;
	float _multiplierHoldTime = 3f;

	void Awake()
	{
		_waveList = new List<GameObject> ();
	}

	void Update()
	{
		_huey.StopAttack (_multiplier >= _text.Length);
	}

	public void Hit(GameObject wave)
	{
		if (_waveList.Contains (wave))
			return;

		_waveList.Add (wave);
		_text [(int)Mathf.Clamp (_multiplier, 0, _text.Length-1)].SetActive (true);
		_multiplier++;
		CancelInvoke ();
		Invoke ("ResetMultiplier", _multiplierHoldTime);
	}

	public void ResetMultiplier()
	{
		CancelInvoke ();
		_waveList.Clear ();
		_multiplier = 0;
	}
}
