﻿using UnityEngine;
using System.Collections;

[RequireComponent(typeof(Rigidbody2D))]
public class ObstacleMove : Actor {
	Player _player;
	Rigidbody2D _rigidBody;

	[SerializeField]
	float _speed = 2f;

	Vector3 _initialScale;

	void Awake () {
		_player = FindObjectOfType<Player> ();
		_rigidBody = GetComponent<Rigidbody2D> ();
		_motion = Vector2.down;
		_initialScale = transform.localScale;
	}

	void Update()
	{
		if (_player != null) {
			transform.localScale = _player.GetScale (_initialScale);
		} else {
			transform.localScale = _initialScale;
		}

		if (_rigidBody.position.y > 10f)
			Destroy (gameObject);
	}

	void FixedUpdate () {
		var newPos = _rigidBody.position + (_motion.normalized * (_speed)) * Time.deltaTime;
		if (_player!=null) {
			newPos.y = Mathf.Lerp (newPos.y, newPos.y - _player.GetSpeed (), Time.deltaTime * 5f);
		} else {
			newPos.y = Mathf.Lerp (newPos.y, newPos.y, Time.deltaTime * 5f);
		}
		_rigidBody.MovePosition(newPos);
	}
}
