﻿using UnityEngine;
using System.Collections;

[RequireComponent(typeof(AudioSource))]
public class TextRandom : MonoBehaviour {
	AudioSource _audioSource;

	void Awake()
	{
		_audioSource = GetComponent<AudioSource> ();
	}

	void Update () {
		transform.localScale = Vector3.one * Random.Range (2f, 4f);
		transform.rotation = Quaternion.Euler (new Vector3 (0f, 0f, Random.Range (-15f, 15f)));
	}

	void OnEnable(){
		if (_audioSource.clip != null)
			_audioSource.Play ();

		Invoke ("Disable", 1.5f);
	}

	void Disable()
	{
		gameObject.SetActive (false);
	}
}
