﻿using UnityEngine;
using System.Collections;

public class Wave : Actor {
	Rigidbody2D _rigidBody;

	[SerializeField]
	SpriteRenderer _waveUpSprite;
	[SerializeField]
	SpriteRenderer _waveSideSprite;

	void Start()
	{
		Destroy (gameObject, 2f);
		_rigidBody = GetComponent<Rigidbody2D> ();
	}

	void Update()
	{
		base.Update ();

		Draw ();
	}

	void Draw()
	{
		if (_direction == Direction.Up) {
			_waveUpSprite.transform.gameObject.SetActive(true);
			_waveSideSprite.transform.gameObject.SetActive (false);
		} else if (_direction == Direction.Left || _direction == Direction.UpLeft) {
			_waveUpSprite.transform.gameObject.SetActive (false);
			_waveSideSprite.transform.gameObject.SetActive(true);
			_waveSideSprite.flipX = false;
		}
		else if (_direction == Direction.Right || _direction == Direction.UpRight) {
			_waveUpSprite.transform.gameObject.SetActive (false);
			_waveSideSprite.transform.gameObject.SetActive(true);
			_waveSideSprite.flipX = true;
		}
	}

	void FixedUpdate(){
		_rigidBody.AddForce(_motion);
	}

	public Vector2 GetMotion()
	{
		return _motion;
	}

	public void SetMotion(Vector2 motion)
	{
		_motion = motion;
	}
}
